#define TELNET_DIALOG       // Compiler direktiv - udkommenter hvis ikke skal glde
using System;
using System.IO;
using System.Net;
using System.Net.Sockets;

namespace SocketClientMedRemoteFasade_WindowsApplication
{
    public class EchoServerFacade :IDisposable
    {
        private string servername;
        private int port;

        private TcpClient serverSocket;
        private NetworkStream netStream;
        private StreamWriter writer;
        private StreamReader reader;

        public EchoServerFacade(string servername, int port)
        {
            this.servername = servername;
            this.port = port;
            open();
        }

        private void open()
        {
            if (serverSocket != null) return;       // m vre ben allerede !!!
            
            // Instantir socket - forbinder socket til server
            serverSocket = new TcpClient(servername, port);
            netStream = serverSocket.GetStream();
            writer = new StreamWriter(netStream);
            reader = new StreamReader(netStream);

            #if TELNET_DIALOG       // Hvis compilerdirektiv er sat medtages koden
                string klarbesked = receiveFromServer(); // vent p klarbesked
                Console.WriteLine("Klarbesked fra server:" + klarbesked);
            #endif
        }

        private void close()
        {
            writer.Close();
            reader.Close();
            netStream.Close();
            serverSocket.Close();
            serverSocket = null;
        }

        private void sendToServer(string text)
        {
            writer.WriteLine(text);
            writer.Flush();
        }

        private string receiveFromServer()
        {
            try
            {
                return reader.ReadLine();
            }
            catch
            {
                return null;
            }
        }
        #region IDisposable Members

        public void Dispose()
        {
            close();
        }

        #endregion

        // Remote metoder

        public string Echo (string text)
        {
            #if TELNET_DIALOG       // Hvis compilerdirektiv er sat medtages koden
                string komandoklarbesked = receiveFromServer(); // vent p klarbesked
                Console.WriteLine("Komando-klarbesked fra server:" + komandoklarbesked);
            #endif

            sendToServer("echo");
            sendToServer(text);
            string response = receiveFromServer();
            return response;
        }

        public string EchoUpper(string text)
        {
            #if TELNET_DIALOG       // Hvis compilerdirektiv er sat medtages koden
                string komandoklarbesked = receiveFromServer(); // vent p klarbesked
                Console.WriteLine("Komando-klarbesked fra server:" + komandoklarbesked);
            #endif

            sendToServer("echoupper");
            sendToServer(text);
            string response = receiveFromServer();
            return response;
        }
    }
}
