#define TELNET_DIALOG       // Compiler direktiv - udkommenter hvis ikke skal glde
using System;
using System.IO;
using System.Net;
using System.Net.Sockets;

namespace SocketEchoServiceLibrary
{
    public class EchoServiceProxyStd :ServiceProxy, IEchoService
    {
        public EchoServiceProxyStd(string servername, int port)
            : base(servername,port)
        {
        }

        #region IEchoService Members

        // Remote metoder

        public string Echo (string text)
        {
            #if TELNET_DIALOG       // Hvis compilerdirektiv er sat medtages koden
                string komandoklarbesked = receiveFromServer(); // vent p klarbesked
                Console.WriteLine("Komando-klarbesked fra server:" + komandoklarbesked);
            #endif

            sendToServer("echo");
            sendToServer(text);
            string response = receiveFromServer();
            return response;
        }

        public string EchoUpper(string text)
        {
            #if TELNET_DIALOG       // Hvis compilerdirektiv er sat medtages koden
                string komandoklarbesked = receiveFromServer(); // vent p klarbesked
                Console.WriteLine("Komando-klarbesked fra server:" + komandoklarbesked);
            #endif

            sendToServer("echoupper");
            sendToServer(text);
            string response = receiveFromServer();
            return response;
        }


        public string EchoLast()
        {
            #if TELNET_DIALOG       // Hvis compilerdirektiv er sat medtages koden
                string komandoklarbesked = receiveFromServer(); // vent p klarbesked
                Console.WriteLine("Komando-klarbesked fra server:" + komandoklarbesked);
            #endif

            sendToServer("echolast");
            string response = receiveFromServer();
            return response;
        }

        #endregion
    }
}
