﻿#define TELNET_DIALOG       // Compiler direktiv - udkommenter hvis ikke skal gælde
using System;
using System.IO;
using System.Net;
using System.Net.Sockets;

namespace SocketEchoServiceLibrary
{
    public class ServiceProxy : IDisposable
    {
        private string servername;
        private int port;

        private TcpClient serverSocket;
        private NetworkStream netStream;
        private StreamWriter writer;
        private StreamReader reader;

        public ServiceProxy(string servername, int port)
        {
            this.servername = servername;
            this.port = port;
            open();
        }

        private void open()
        {
            if (serverSocket != null) return;       // må være åben allerede !!!

            // Instantiér socket - forbinder socket til server
            serverSocket = new TcpClient(servername, port);
            netStream = serverSocket.GetStream();
            writer = new StreamWriter(netStream);
            reader = new StreamReader(netStream);

            #if TELNET_DIALOG       // Hvis compilerdirektiv er sat medtages koden
                string klarbesked = receiveFromServer(); // vent på klarbesked
                Console.WriteLine("Klarbesked fra server:" + klarbesked);
            #endif
        }

        private void close()
        {
            writer.Close();
            reader.Close();
            netStream.Close();
            serverSocket.Close();
            serverSocket = null;
        }

        protected void sendToServer(string text)
        {
            writer.WriteLine(text);
            writer.Flush();
        }

        protected string receiveFromServer()
        {
            try
            {
                return reader.ReadLine();
            }
            catch
            {
                return null;
            }
        }
        #region IDisposable Members

        public void Dispose()
        {
            close();
        }

        #endregion
    }
}
