#define TELNET_DIALOG       // Compiler direktiv - udkommenter hvis ikke skal glde
using System;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Collections.Generic;

namespace SocketServerCmdBasedStatic
{
	public class ClientHandler
	{
        private Socket clientSocket;
		private	NetworkStream netStream;
		private	StreamWriter writer;
		private	StreamReader reader;

        public ClientHandler(Socket clientSocket)
		{
			this.clientSocket = clientSocket;
		}

		public void RunClient ()
		{
		    netStream = new NetworkStream(clientSocket);
		    writer = new StreamWriter (netStream);
		    reader = new StreamReader (netStream);

            doDialog();
				
		    writer.Close();
		    reader.Close();
		    netStream.Close();
            clientSocket.Shutdown(SocketShutdown.Both);
		    clientSocket.Close();
		}

        private void sendToClient(string text)
        {
            writer.WriteLine(text);
            writer.Flush();
        }

        private string receiveFromClient()
        {
            try
            {
                return reader.ReadLine();
            }
            catch
            {
                return null;
            }
        }

        private void doDialog()
        {
            #if TELNET_DIALOG       // Hvis compilerdirektiv er sat medtages koden
                sendToClient("Server klar"); // opstarts besked til klient
            #endif

            while (executeCommand());           // udfr slnge der returneres true
        }
        private bool executeCommand()  //returner false hvis null eller bye
        {
            #if TELNET_DIALOG       // Hvis compilerdirektiv er sat medtages koden
                        sendToClient("Indtast komando"); // besked til klient
            #endif

            string command;
            command = receiveFromClient();
            if (command == null)
                return false;       // ikke mere input
            switch (command.Trim().ToLower())
            {
                case "echo":
                    {   // local scope s varable ikke ses uden for
                        string inputMsg = receiveFromClient();          // hent supplerende parametre fra klient
                        string response = EchoService.Echo(inputMsg);   // udfr metode
                        sendToClient(response);                         // send returvrdi til klient
                    }
                    break;
                case "echoupper":
                    {   // local scope s varable ikke ses uden for
                        string inputMsg = receiveFromClient();          // hent supplerende parametre fra klient
                        string response = EchoService.EchoUpper(inputMsg);// udfr metode
                        sendToClient(response);                         // send returvrdi til klient
                    }
                    break;                
                case "bye":
                    return false;
                default:
                    sendToClient("Ukendt komando");
                    break;
            }
            return true;
        }
	}
}
