using System;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.Collections.Generic;
using System.Collections;

namespace SocketServerCmdDisconnectedSession
{

	public class Server
	{
        // server data - gemmes i objekt s de kan tilgs af metoder p server objektet
        private Dictionary<String, Session> sessioner = new Dictionary<string, Session>();
        private int lastSessionId = 0;

        public Server(int port)
		{
			System.Console.WriteLine("Server startet p port:"+port);

            TcpListener listener = new TcpListener(IPAddress.Any, port);

            listener.Start();
			while (true)
			{
				System.Console.WriteLine("server klar");

				Socket clientSocket = listener.AcceptSocket();

				System.Console.WriteLine("Der er get en i flden");

				ClientHandler handler = new ClientHandler(clientSocket, this);      // med adgang til server-metoder
//				handler.RunClient();		// Kun een af gangen
								
				// Her sttes op til af behandling foregr parallel
				// s der kan fortsttes med en ny
                Thread clientTrd = new Thread(handler.RunClient);
				clientTrd.Start();
			}
		}

        public Session StartSession()   // ikke synkroniseret
        {
            ++lastSessionId;
            Session nySession = new Session(lastSessionId.ToString());
            sessioner.Add(nySession.SessionId,nySession);

            #if DEBUG       // Hvis compilerdirektiv er sat medtages koden
            Console.WriteLine("SessionId: " + nySession.SessionId + " er nu startet");
            #endif

            return nySession;
        }

        public void EndSession(Session session)   // ikke synkroniseret
        {
            sessioner.Remove(session.SessionId);
            
            #if DEBUG       // Hvis compilerdirektiv er sat medtages koden
            Console.WriteLine("SessionId: " + session.SessionId + " er nu afsluttet");
            #endif
        }

        public Session GetSession(string sessionId)   // ikke synkroniseret
        {
            if (sessioner.ContainsKey(sessionId))
                return sessioner[sessionId];
            return null;
        }

    }
}
